/**
 * Hydra OAuth2 & OpenID Connect Server
 * Please refer to the user guide for in-depth documentation: https://ory.gitbooks.io/hydra/content/   Hydra offers OAuth 2.0 and OpenID Connect Core 1.0 capabilities as a service. Hydra is different, because it works with any existing authentication infrastructure, not just LDAP or SAML. By implementing a consent app (works with any programming language) you build a bridge between Hydra and your authentication infrastructure. Hydra is able to securely manage JSON Web Keys, and has a sophisticated policy-based access control you can use if you want to. Hydra is suitable for green- (new) and brownfield (existing) projects. If you are not familiar with OAuth 2.0 and are working on a greenfield project, we recommend evaluating if OAuth 2.0 really serves your purpose. Knowledge of OAuth 2.0 is imperative in understanding what Hydra does and how it works.   The official repository is located at https://github.com/ory/hydra   ### Important REST API Documentation Notes  The swagger generator used to create this documentation does currently not support example responses. To see request and response payloads click on **\"Show JSON schema\"**: ![Enable JSON Schema on Apiary](https://storage.googleapis.com/ory.am/hydra/json-schema.png)   The API documentation always refers to the latest tagged version of ORY Hydra. For previous API documentations, please refer to https://github.com/ory/hydra/blob/<tag-id>/docs/api.swagger.yaml - for example:  0.9.13: https://github.com/ory/hydra/blob/v0.9.13/docs/api.swagger.yaml 0.8.1: https://github.com/ory/hydra/blob/v0.8.1/docs/api.swagger.yaml
 *
 * OpenAPI spec version: Latest
 * Contact: hi@ory.am
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

;(function(factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(
      [
        'ApiClient',
        'model/ConsentRequest',
        'model/ConsentRequestAcceptance',
        'model/ConsentRequestManager',
        'model/ConsentRequestRejection',
        'model/Context',
        'model/Firewall',
        'model/Group',
        'model/GroupMembers',
        'model/Handler',
        'model/InlineResponse200',
        'model/InlineResponse2001',
        'model/InlineResponse401',
        'model/JoseWebKeySetRequest',
        'model/JsonWebKey',
        'model/JsonWebKeySet',
        'model/JsonWebKeySetGeneratorRequest',
        'model/KeyGenerator',
        'model/Manager',
        'model/OAuth2Client',
        'model/OAuth2ConsentRequest',
        'model/OAuth2TokenIntrospection',
        'model/Policy',
        'model/PolicyConditions',
        'model/RawMessage',
        'model/SwaggerAcceptConsentRequest',
        'model/SwaggerCreatePolicyParameters',
        'model/SwaggerDoesWardenAllowAccessRequestParameters',
        'model/SwaggerDoesWardenAllowTokenAccessRequestParameters',
        'model/SwaggerGetPolicyParameters',
        'model/SwaggerJsonWebKeyQuery',
        'model/SwaggerJwkCreateSet',
        'model/SwaggerJwkSetQuery',
        'model/SwaggerJwkUpdateSet',
        'model/SwaggerJwkUpdateSetKey',
        'model/SwaggerListPolicyParameters',
        'model/SwaggerListPolicyResponse',
        'model/SwaggerOAuthConsentRequest',
        'model/SwaggerOAuthConsentRequestPayload',
        'model/SwaggerOAuthIntrospectionRequest',
        'model/SwaggerOAuthIntrospectionResponse',
        'model/SwaggerOAuthTokenResponse',
        'model/SwaggerOAuthTokenResponseBody',
        'model/SwaggerRejectConsentRequest',
        'model/SwaggerRevokeOAuth2TokenParameters',
        'model/SwaggerUpdatePolicyParameters',
        'model/SwaggerWardenAccessRequestResponseParameters',
        'model/SwaggerWardenTokenAccessRequestResponse',
        'model/SwaggeruserinfoResponse',
        'model/SwaggeruserinfoResponsePayload',
        'model/TokenAllowedRequest',
        'model/WardenAccessRequest',
        'model/WardenAccessRequestResponse',
        'model/WardenTokenAccessRequest',
        'model/WardenTokenAccessRequestResponse',
        'model/WellKnown',
        'model/Writer',
        'api/HealthApi',
        'api/JsonWebKeyApi',
        'api/OAuth2Api',
        'api/PolicyApi',
        'api/WardenApi'
      ],
      factory
    )
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(
      require('./ApiClient'),
      require('./model/ConsentRequest'),
      require('./model/ConsentRequestAcceptance'),
      require('./model/ConsentRequestManager'),
      require('./model/ConsentRequestRejection'),
      require('./model/Context'),
      require('./model/Firewall'),
      require('./model/Group'),
      require('./model/GroupMembers'),
      require('./model/Handler'),
      require('./model/InlineResponse200'),
      require('./model/InlineResponse2001'),
      require('./model/InlineResponse401'),
      require('./model/JoseWebKeySetRequest'),
      require('./model/JsonWebKey'),
      require('./model/JsonWebKeySet'),
      require('./model/JsonWebKeySetGeneratorRequest'),
      require('./model/KeyGenerator'),
      require('./model/Manager'),
      require('./model/OAuth2Client'),
      require('./model/OAuth2ConsentRequest'),
      require('./model/OAuth2TokenIntrospection'),
      require('./model/Policy'),
      require('./model/PolicyConditions'),
      require('./model/RawMessage'),
      require('./model/SwaggerAcceptConsentRequest'),
      require('./model/SwaggerCreatePolicyParameters'),
      require('./model/SwaggerDoesWardenAllowAccessRequestParameters'),
      require('./model/SwaggerDoesWardenAllowTokenAccessRequestParameters'),
      require('./model/SwaggerGetPolicyParameters'),
      require('./model/SwaggerJsonWebKeyQuery'),
      require('./model/SwaggerJwkCreateSet'),
      require('./model/SwaggerJwkSetQuery'),
      require('./model/SwaggerJwkUpdateSet'),
      require('./model/SwaggerJwkUpdateSetKey'),
      require('./model/SwaggerListPolicyParameters'),
      require('./model/SwaggerListPolicyResponse'),
      require('./model/SwaggerOAuthConsentRequest'),
      require('./model/SwaggerOAuthConsentRequestPayload'),
      require('./model/SwaggerOAuthIntrospectionRequest'),
      require('./model/SwaggerOAuthIntrospectionResponse'),
      require('./model/SwaggerOAuthTokenResponse'),
      require('./model/SwaggerOAuthTokenResponseBody'),
      require('./model/SwaggerRejectConsentRequest'),
      require('./model/SwaggerRevokeOAuth2TokenParameters'),
      require('./model/SwaggerUpdatePolicyParameters'),
      require('./model/SwaggerWardenAccessRequestResponseParameters'),
      require('./model/SwaggerWardenTokenAccessRequestResponse'),
      require('./model/SwaggeruserinfoResponse'),
      require('./model/SwaggeruserinfoResponsePayload'),
      require('./model/TokenAllowedRequest'),
      require('./model/WardenAccessRequest'),
      require('./model/WardenAccessRequestResponse'),
      require('./model/WardenTokenAccessRequest'),
      require('./model/WardenTokenAccessRequestResponse'),
      require('./model/WellKnown'),
      require('./model/Writer'),
      require('./api/HealthApi'),
      require('./api/JsonWebKeyApi'),
      require('./api/OAuth2Api'),
      require('./api/PolicyApi'),
      require('./api/WardenApi')
    )
  }
})(function(
  ApiClient,
  ConsentRequest,
  ConsentRequestAcceptance,
  ConsentRequestManager,
  ConsentRequestRejection,
  Context,
  Firewall,
  Group,
  GroupMembers,
  Handler,
  InlineResponse200,
  InlineResponse2001,
  InlineResponse401,
  JoseWebKeySetRequest,
  JsonWebKey,
  JsonWebKeySet,
  JsonWebKeySetGeneratorRequest,
  KeyGenerator,
  Manager,
  OAuth2Client,
  OAuth2ConsentRequest,
  OAuth2TokenIntrospection,
  Policy,
  PolicyConditions,
  RawMessage,
  SwaggerAcceptConsentRequest,
  SwaggerCreatePolicyParameters,
  SwaggerDoesWardenAllowAccessRequestParameters,
  SwaggerDoesWardenAllowTokenAccessRequestParameters,
  SwaggerGetPolicyParameters,
  SwaggerJsonWebKeyQuery,
  SwaggerJwkCreateSet,
  SwaggerJwkSetQuery,
  SwaggerJwkUpdateSet,
  SwaggerJwkUpdateSetKey,
  SwaggerListPolicyParameters,
  SwaggerListPolicyResponse,
  SwaggerOAuthConsentRequest,
  SwaggerOAuthConsentRequestPayload,
  SwaggerOAuthIntrospectionRequest,
  SwaggerOAuthIntrospectionResponse,
  SwaggerOAuthTokenResponse,
  SwaggerOAuthTokenResponseBody,
  SwaggerRejectConsentRequest,
  SwaggerRevokeOAuth2TokenParameters,
  SwaggerUpdatePolicyParameters,
  SwaggerWardenAccessRequestResponseParameters,
  SwaggerWardenTokenAccessRequestResponse,
  SwaggeruserinfoResponse,
  SwaggeruserinfoResponsePayload,
  TokenAllowedRequest,
  WardenAccessRequest,
  WardenAccessRequestResponse,
  WardenTokenAccessRequest,
  WardenTokenAccessRequestResponse,
  WellKnown,
  Writer,
  HealthApi,
  JsonWebKeyApi,
  OAuth2Api,
  PolicyApi,
  WardenApi
) {
  'use strict'

  /**
   * Please_refer_to_the_user_guide_for_in_depth_documentation_httpsory_gitbooks_iohydracontentHydra_offers_OAuth_2_0_and_OpenID_Connect_Core_1_0_capabilities_as_a_service__Hydra_is_different_because_it_works_with_any_existing_authentication_infrastructure_not_just_LDAP_or_SAML__By_implementing_a_consent_app__works_with_any_programming_language_you_build_a_bridge_between_Hydra_and_your_authentication_infrastructure_Hydra_is_able_to_securely_manage_JSON_Web_Keys_and_has_a_sophisticated_policy_based_access_control_you_can_use_if_you_want_to_Hydra_is_suitable_for_green___new_and_brownfield__existing_projects__If_you_are_not_familiar_with_OAuth_2_0_and_are_working_on_a_greenfield_project_we_recommend_evaluating_if_OAuth_2_0_really_serves_your_purpose__Knowledge_of_OAuth_2_0_is_imperative_in_understanding_what_Hydra_does_and_how_it_works_The_official_repository_is_located_at_httpsgithub_comoryhydra_Important_REST_API_Documentation_NotesThe_swagger_generator_used_to_create_this_documentation_does_currently_not_support_example_responses__To_seerequest_and_response_payloads_click_on_Show_JSON_schema_Enable_JSON_Schema_on_Apiary_httpsstorage_googleapis_comory_amhydrajson_schema_pngThe_API_documentation_always_refers_to_the_latest_tagged_version_of_ORY_Hydra__For_previous_API_documentations_pleaserefer_to_httpsgithub_comoryhydrablobtag_iddocsapi_swagger_yaml___for_example0_9_13_httpsgithub_comoryhydrablobv0_9_13docsapi_swagger_yaml0_8_1_httpsgithub_comoryhydrablobv0_8_1docsapi_swagger_yaml.<br>
   * The <code>index</code> module provides access to constructors for all the classes which comprise the public API.
   * <p>
   * An AMD (recommended!) or CommonJS application will generally do something equivalent to the following:
   * <pre>
   * var HydraOAuth2OpenIdConnectServer = require('index'); // See note below*.
   * var xxxSvc = new HydraOAuth2OpenIdConnectServer.XxxApi(); // Allocate the API class we're going to use.
   * var yyyModel = new HydraOAuth2OpenIdConnectServer.Yyy(); // Construct a model instance.
   * yyyModel.someProperty = 'someValue';
   * ...
   * var zzz = xxxSvc.doSomething(yyyModel); // Invoke the service.
   * ...
   * </pre>
   * <em>*NOTE: For a top-level AMD script, use require(['index'], function(){...})
   * and put the application logic within the callback function.</em>
   * </p>
   * <p>
   * A non-AMD browser application (discouraged) might do something like this:
   * <pre>
   * var xxxSvc = new HydraOAuth2OpenIdConnectServer.XxxApi(); // Allocate the API class we're going to use.
   * var yyy = new HydraOAuth2OpenIdConnectServer.Yyy(); // Construct a model instance.
   * yyyModel.someProperty = 'someValue';
   * ...
   * var zzz = xxxSvc.doSomething(yyyModel); // Invoke the service.
   * ...
   * </pre>
   * </p>
   * @module index
   * @version Latest
   */
  var exports = {
    /**
     * The ApiClient constructor.
     * @property {module:ApiClient}
     */
    ApiClient: ApiClient,
    /**
     * The ConsentRequest model constructor.
     * @property {module:model/ConsentRequest}
     */
    ConsentRequest: ConsentRequest,
    /**
     * The ConsentRequestAcceptance model constructor.
     * @property {module:model/ConsentRequestAcceptance}
     */
    ConsentRequestAcceptance: ConsentRequestAcceptance,
    /**
     * The ConsentRequestManager model constructor.
     * @property {module:model/ConsentRequestManager}
     */
    ConsentRequestManager: ConsentRequestManager,
    /**
     * The ConsentRequestRejection model constructor.
     * @property {module:model/ConsentRequestRejection}
     */
    ConsentRequestRejection: ConsentRequestRejection,
    /**
     * The Context model constructor.
     * @property {module:model/Context}
     */
    Context: Context,
    /**
     * The Firewall model constructor.
     * @property {module:model/Firewall}
     */
    Firewall: Firewall,
    /**
     * The Group model constructor.
     * @property {module:model/Group}
     */
    Group: Group,
    /**
     * The GroupMembers model constructor.
     * @property {module:model/GroupMembers}
     */
    GroupMembers: GroupMembers,
    /**
     * The Handler model constructor.
     * @property {module:model/Handler}
     */
    Handler: Handler,
    /**
     * The InlineResponse200 model constructor.
     * @property {module:model/InlineResponse200}
     */
    InlineResponse200: InlineResponse200,
    /**
     * The InlineResponse2001 model constructor.
     * @property {module:model/InlineResponse2001}
     */
    InlineResponse2001: InlineResponse2001,
    /**
     * The InlineResponse401 model constructor.
     * @property {module:model/InlineResponse401}
     */
    InlineResponse401: InlineResponse401,
    /**
     * The JoseWebKeySetRequest model constructor.
     * @property {module:model/JoseWebKeySetRequest}
     */
    JoseWebKeySetRequest: JoseWebKeySetRequest,
    /**
     * The JsonWebKey model constructor.
     * @property {module:model/JsonWebKey}
     */
    JsonWebKey: JsonWebKey,
    /**
     * The JsonWebKeySet model constructor.
     * @property {module:model/JsonWebKeySet}
     */
    JsonWebKeySet: JsonWebKeySet,
    /**
     * The JsonWebKeySetGeneratorRequest model constructor.
     * @property {module:model/JsonWebKeySetGeneratorRequest}
     */
    JsonWebKeySetGeneratorRequest: JsonWebKeySetGeneratorRequest,
    /**
     * The KeyGenerator model constructor.
     * @property {module:model/KeyGenerator}
     */
    KeyGenerator: KeyGenerator,
    /**
     * The Manager model constructor.
     * @property {module:model/Manager}
     */
    Manager: Manager,
    /**
     * The OAuth2Client model constructor.
     * @property {module:model/OAuth2Client}
     */
    OAuth2Client: OAuth2Client,
    /**
     * The OAuth2ConsentRequest model constructor.
     * @property {module:model/OAuth2ConsentRequest}
     */
    OAuth2ConsentRequest: OAuth2ConsentRequest,
    /**
     * The OAuth2TokenIntrospection model constructor.
     * @property {module:model/OAuth2TokenIntrospection}
     */
    OAuth2TokenIntrospection: OAuth2TokenIntrospection,
    /**
     * The Policy model constructor.
     * @property {module:model/Policy}
     */
    Policy: Policy,
    /**
     * The PolicyConditions model constructor.
     * @property {module:model/PolicyConditions}
     */
    PolicyConditions: PolicyConditions,
    /**
     * The RawMessage model constructor.
     * @property {module:model/RawMessage}
     */
    RawMessage: RawMessage,
    /**
     * The SwaggerAcceptConsentRequest model constructor.
     * @property {module:model/SwaggerAcceptConsentRequest}
     */
    SwaggerAcceptConsentRequest: SwaggerAcceptConsentRequest,
    /**
     * The SwaggerCreatePolicyParameters model constructor.
     * @property {module:model/SwaggerCreatePolicyParameters}
     */
    SwaggerCreatePolicyParameters: SwaggerCreatePolicyParameters,
    /**
     * The SwaggerDoesWardenAllowAccessRequestParameters model constructor.
     * @property {module:model/SwaggerDoesWardenAllowAccessRequestParameters}
     */
    SwaggerDoesWardenAllowAccessRequestParameters: SwaggerDoesWardenAllowAccessRequestParameters,
    /**
     * The SwaggerDoesWardenAllowTokenAccessRequestParameters model constructor.
     * @property {module:model/SwaggerDoesWardenAllowTokenAccessRequestParameters}
     */
    SwaggerDoesWardenAllowTokenAccessRequestParameters: SwaggerDoesWardenAllowTokenAccessRequestParameters,
    /**
     * The SwaggerGetPolicyParameters model constructor.
     * @property {module:model/SwaggerGetPolicyParameters}
     */
    SwaggerGetPolicyParameters: SwaggerGetPolicyParameters,
    /**
     * The SwaggerJsonWebKeyQuery model constructor.
     * @property {module:model/SwaggerJsonWebKeyQuery}
     */
    SwaggerJsonWebKeyQuery: SwaggerJsonWebKeyQuery,
    /**
     * The SwaggerJwkCreateSet model constructor.
     * @property {module:model/SwaggerJwkCreateSet}
     */
    SwaggerJwkCreateSet: SwaggerJwkCreateSet,
    /**
     * The SwaggerJwkSetQuery model constructor.
     * @property {module:model/SwaggerJwkSetQuery}
     */
    SwaggerJwkSetQuery: SwaggerJwkSetQuery,
    /**
     * The SwaggerJwkUpdateSet model constructor.
     * @property {module:model/SwaggerJwkUpdateSet}
     */
    SwaggerJwkUpdateSet: SwaggerJwkUpdateSet,
    /**
     * The SwaggerJwkUpdateSetKey model constructor.
     * @property {module:model/SwaggerJwkUpdateSetKey}
     */
    SwaggerJwkUpdateSetKey: SwaggerJwkUpdateSetKey,
    /**
     * The SwaggerListPolicyParameters model constructor.
     * @property {module:model/SwaggerListPolicyParameters}
     */
    SwaggerListPolicyParameters: SwaggerListPolicyParameters,
    /**
     * The SwaggerListPolicyResponse model constructor.
     * @property {module:model/SwaggerListPolicyResponse}
     */
    SwaggerListPolicyResponse: SwaggerListPolicyResponse,
    /**
     * The SwaggerOAuthConsentRequest model constructor.
     * @property {module:model/SwaggerOAuthConsentRequest}
     */
    SwaggerOAuthConsentRequest: SwaggerOAuthConsentRequest,
    /**
     * The SwaggerOAuthConsentRequestPayload model constructor.
     * @property {module:model/SwaggerOAuthConsentRequestPayload}
     */
    SwaggerOAuthConsentRequestPayload: SwaggerOAuthConsentRequestPayload,
    /**
     * The SwaggerOAuthIntrospectionRequest model constructor.
     * @property {module:model/SwaggerOAuthIntrospectionRequest}
     */
    SwaggerOAuthIntrospectionRequest: SwaggerOAuthIntrospectionRequest,
    /**
     * The SwaggerOAuthIntrospectionResponse model constructor.
     * @property {module:model/SwaggerOAuthIntrospectionResponse}
     */
    SwaggerOAuthIntrospectionResponse: SwaggerOAuthIntrospectionResponse,
    /**
     * The SwaggerOAuthTokenResponse model constructor.
     * @property {module:model/SwaggerOAuthTokenResponse}
     */
    SwaggerOAuthTokenResponse: SwaggerOAuthTokenResponse,
    /**
     * The SwaggerOAuthTokenResponseBody model constructor.
     * @property {module:model/SwaggerOAuthTokenResponseBody}
     */
    SwaggerOAuthTokenResponseBody: SwaggerOAuthTokenResponseBody,
    /**
     * The SwaggerRejectConsentRequest model constructor.
     * @property {module:model/SwaggerRejectConsentRequest}
     */
    SwaggerRejectConsentRequest: SwaggerRejectConsentRequest,
    /**
     * The SwaggerRevokeOAuth2TokenParameters model constructor.
     * @property {module:model/SwaggerRevokeOAuth2TokenParameters}
     */
    SwaggerRevokeOAuth2TokenParameters: SwaggerRevokeOAuth2TokenParameters,
    /**
     * The SwaggerUpdatePolicyParameters model constructor.
     * @property {module:model/SwaggerUpdatePolicyParameters}
     */
    SwaggerUpdatePolicyParameters: SwaggerUpdatePolicyParameters,
    /**
     * The SwaggerWardenAccessRequestResponseParameters model constructor.
     * @property {module:model/SwaggerWardenAccessRequestResponseParameters}
     */
    SwaggerWardenAccessRequestResponseParameters: SwaggerWardenAccessRequestResponseParameters,
    /**
     * The SwaggerWardenTokenAccessRequestResponse model constructor.
     * @property {module:model/SwaggerWardenTokenAccessRequestResponse}
     */
    SwaggerWardenTokenAccessRequestResponse: SwaggerWardenTokenAccessRequestResponse,
    /**
     * The SwaggeruserinfoResponse model constructor.
     * @property {module:model/SwaggeruserinfoResponse}
     */
    SwaggeruserinfoResponse: SwaggeruserinfoResponse,
    /**
     * The SwaggeruserinfoResponsePayload model constructor.
     * @property {module:model/SwaggeruserinfoResponsePayload}
     */
    SwaggeruserinfoResponsePayload: SwaggeruserinfoResponsePayload,
    /**
     * The TokenAllowedRequest model constructor.
     * @property {module:model/TokenAllowedRequest}
     */
    TokenAllowedRequest: TokenAllowedRequest,
    /**
     * The WardenAccessRequest model constructor.
     * @property {module:model/WardenAccessRequest}
     */
    WardenAccessRequest: WardenAccessRequest,
    /**
     * The WardenAccessRequestResponse model constructor.
     * @property {module:model/WardenAccessRequestResponse}
     */
    WardenAccessRequestResponse: WardenAccessRequestResponse,
    /**
     * The WardenTokenAccessRequest model constructor.
     * @property {module:model/WardenTokenAccessRequest}
     */
    WardenTokenAccessRequest: WardenTokenAccessRequest,
    /**
     * The WardenTokenAccessRequestResponse model constructor.
     * @property {module:model/WardenTokenAccessRequestResponse}
     */
    WardenTokenAccessRequestResponse: WardenTokenAccessRequestResponse,
    /**
     * The WellKnown model constructor.
     * @property {module:model/WellKnown}
     */
    WellKnown: WellKnown,
    /**
     * The Writer model constructor.
     * @property {module:model/Writer}
     */
    Writer: Writer,
    /**
     * The HealthApi service constructor.
     * @property {module:api/HealthApi}
     */
    HealthApi: HealthApi,
    /**
     * The JsonWebKeyApi service constructor.
     * @property {module:api/JsonWebKeyApi}
     */
    JsonWebKeyApi: JsonWebKeyApi,
    /**
     * The OAuth2Api service constructor.
     * @property {module:api/OAuth2Api}
     */
    OAuth2Api: OAuth2Api,
    /**
     * The PolicyApi service constructor.
     * @property {module:api/PolicyApi}
     */
    PolicyApi: PolicyApi,
    /**
     * The WardenApi service constructor.
     * @property {module:api/WardenApi}
     */
    WardenApi: WardenApi
  }

  return exports
})
